'    PROGRAM GEDCOMMA
'    Read a GEDCOM file, converting place lines to preferred format.
'     Possible options are to add leading commas (i.e. ensure that all
'     place lines include three commas so that the last field (country)
'     is placed in the level 4 location field by PAF) or else delete any
'     leading commas so that the first field containing information is
'     always placed in the level 1 location field, and any blank location
'     fields will be in the level 4, level 3 etc. position.
'    Modified 22 June 1994 to automatically convert dates that are not
'     accepted by PAF (PRE is converted to BEF, CIRCA is converted to ABT)
'    Modified 27 June 1994 to include option to automatically attempt to
'     modify place name parts that are too long to import into PAF


DECLARE SUB CheckLineType (LineString$, LineType$)
DECLARE SUB LeadCommaDel (LineString$)
DECLARE SUB InsertLeadCommas (LineString$)
DECLARE SUB ConvertDate (LineString$)
DECLARE SUB CheckNameLength (LineString$)
DECLARE SUB DisplayFiles (MaxChoice AS INTEGER)
DECLARE SUB FunctionLine (f1 AS STRING, f2 AS STRING, f3 AS STRING, f4 AS STRING, f5 AS STRING, f6 AS STRING, f7 AS STRING, f8 AS STRING, f9 AS STRING, f10 AS STRING)
DECLARE SUB GetDirectory (Text AS STRING, StartCol AS INTEGER)
DECLARE SUB GetSelection (MaxChoice AS INTEGER)
DECLARE SUB Screenprep (f1 AS STRING, f2 AS STRING, f3 AS STRING, f4 AS STRING, f5 AS STRING, f6 AS STRING, f7 AS STRING, f8 AS STRING, f9 AS STRING, f10 AS STRING)
DECLARE SUB SelectFile (Text AS STRING, StartCol AS INTEGER)
DECLARE SUB TopLine ()

        COMMON SHARED Date() AS STRING
        COMMON SHARED FileName AS STRING
        COMMON SHARED FileName() AS STRING
        COMMON SHARED FSize() AS STRING
        COMMON SHARED Path AS STRING
        COMMON SHARED Prog AS STRING
        COMMON SHARED Rec AS STRING
        COMMON SHARED RecordIn AS STRING
        COMMON SHARED TextLine AS STRING
        COMMON SHARED Time() AS STRING
        COMMON SHARED Title AS STRING
        COMMON SHARED XChoice AS INTEGER
        COMMON SHARED XFile AS INTEGER
        COMMON SHARED XRec AS INTEGER
      
        REDIM FileName(1 TO 50) AS STRING
        REDIM Date(1 TO 50) AS STRING
        REDIM Time(1 TO 50) AS STRING
        REDIM FSize(1 TO 50) AS STRING

                                   
     ON KEY(10) GOSUB finish
    
     KEY(10) ON
     Title = "Insert/Delete Commas in Place Lines of GEDCOM File"
     Prog = "GEDCOMMA"
    
     TextLine = SPACE$(80)
   
     CALL Screenprep("", "", "", "", "", "", "", "", "", "Exit")
     LOCATE 3, 6
     PRINT "This program allows you to modify the place format of GEDCOM files"
     LOCATE 4, 6
     PRINT "before importing them into PAF.  In GEDCOM, the PAF program uses"
     LOCATE 5, 6
     PRINT "commas in place names to determine which location level to place a"
     LOCATE 6, 6
     PRINT "particular part of a place name into.  I wrote this program because"
     LOCATE 7, 6
     PRINT "I found that when I download from the IGI locations are placed in"
     LOCATE 8, 6
     PRINT "the GEDCOM file without leading commas.  This meant that a place"
     LOCATE 9, 6
     PRINT "shown as Christchurch,New Zealand from the IGI ended up in PAF with"
     LOCATE 10, 6
     PRINT "Christchurch in level 1, New Zealand in level 2, and levels 3 and 4"
     LOCATE 11, 6
     PRINT "blank!  Because there are some people who prefer to have their data"
     LOCATE 12, 6
     PRINT "this way, I have also included an option to delete the leading"
     LOCATE 13, 6
     PRINT "commas in a GEDCOM file that has the places formatted so that the"
     LOCATE 14, 6
     PRINT "last location field is always placed in level four by PAF and any"
     LOCATE 15, 6
     PRINT "blank levels are at the beginning."
     LOCATE 17, 6
     PRINT "Do you want to continue? (Y/N)"
     LOCATE 20, 3
     PRINT "This program may be freely distributed provided credit is given to the"
     LOCATE 21, 3
     PRINT "author Grant O'Neil  54 Meadowview Drive, Ballajura, Western Australia 6066"
     Continue$ = " "
     DO
          Continue$ = UCASE$(INKEY$)
          LOCATE 17, 38: PRINT Continue$
     LOOP UNTIL INSTR(" YN", Continue$) > 1
     IF Continue$ = "N" THEN GOSUB finish

     WHILE Prog = "GEDCOMMA"

          CALL Screenprep("", "", "", "", "", "", "", "", "", "Exit")
          LOCATE 4, 6
          PRINT "Do you want to ADD or DELETE leading commas in place lines"
          LOCATE 5, 6
          PRINT "of the GEDCOM file? (A/D)"
          CommaProcess$ = " "
          DO
               CommaProcess$ = UCASE$(INKEY$)
               LOCATE 5, 36: PRINT CommaProcess$
          LOOP UNTIL INSTR(" AD", CommaProcess$) > 1
          IF CommaProcess$ = "A" THEN
               LOCATE 5, 36: PRINT "ADD"
               Title = "Insert Commas in Place Lines of GEDCOM File"
          ELSE
               LOCATE 5, 36: PRINT "DELETE"
               Title = "Delete Commas in Place Lines of GEDCOM File"
          END IF

          LOCATE 8, 6
          PRINT "Do you want to automatically modify long place names? (Y/N) "
          LOCATE 9, 6
          PRINT "If you select 'Y' here, this program will attempt to modify any place"
          LOCATE 10, 6
          PRINT "name parts it encounters that would be too long to fit in a PAF"
          LOCATE 11, 6
          PRINT "location field.  e.g. 'Frampton on Severn' would be modified so that"
          LOCATE 12, 6
          PRINT "'Frampton' and 'on Severn' were in two separate location fields."
          LongModify$ = " "
          DO
               LongModify$ = UCASE$(INKEY$)
               LOCATE 8, 66: PRINT LongModify$
          LOOP UNTIL INSTR(" YN", LongModify$) > 1
         
          LOCATE 15, 6
          PRINT "Please enter the path where the GEDCOM file is found"
          LOCATE 16, 6
          PRINT "e.g. C:\PAF\DATA"
          Path$ = " "
          LOCATE 16, 28: INPUT " ", Path$
          IF LEN(Path$) > 0 THEN
              IF MID$(Path$, (LEN(Path$))) <> "\" THEN
                    Path$ = Path$ + "\"
              END IF
          END IF
        
          CALL SelectFile("", 1)
          OPEN Path$ + RTRIM$(FileName(XFile)) + ".ged" FOR INPUT AS #1
          LINE INPUT #1, RecordIn
          FileName = Path$ + RTRIM$(FileName(XFile)) + ".mod"
          OPEN FileName FOR OUTPUT AS #2
          WHILE NOT EOF(1)
               LineString$ = RecordIn
               CALL CheckLineType(LineString$, LineType$)
               IF LineType$ = "P" THEN
                   IF LongModify$ = "Y" THEN
                        CALL LeadCommaDel(LineString$)
                        CALL CheckNameLength(LineString$)
                   END IF
                   IF CommaProcess$ = "A" THEN
                        CALL InsertLeadCommas(LineString$)
                   ELSE
                        CALL LeadCommaDel(LineString$)
                   END IF
               END IF
               IF LineType$ = "D" THEN
                   CALL ConvertDate(LineString$)
               END IF
               PRINT #2, LineString$
               LINE INPUT #1, RecordIn
          WEND
          LineString$ = RecordIn
          PRINT #2, LineString$
          CLOSE
                          
          CALL Screenprep("", "", "", "", "", "", "", "", "", "Exit")
          LOCATE 4, 6
          PRINT "Do you want to rename the converted file? (Y/N)"
          LOCATE 7, 6
          PRINT "If you do not choose to rename the file, the original GEDCOM file will"
          LOCATE 8, 6
          PRINT "be renamed to "; RTRIM$(FileName(XFile)); ".OLD and the modified file will have the name"
          LOCATE 9, 6
          PRINT RTRIM$(FileName(XFile)); ".GED"
          Rename$ = " "
          DO
                Rename$ = UCASE$(INKEY$)
                LOCATE 4, 55: PRINT Rename$
          LOOP UNTIL INSTR(" YN", Rename$) > 1
          IF Rename$ = "N" THEN
              SHELL "ren " + Path$ + RTRIM$(FileName(XFile)) + ".ged " + RTRIM$(FileName(XFile)) + ".old"
              SHELL "ren " + Path$ + RTRIM$(FileName(XFile)) + ".mod " + RTRIM$(FileName(XFile)) + ".ged"
                           
              CALL Screenprep("", "", "", "", "", "", "", "", "", "Exit")
              LOCATE 4, 6
              PRINT "GEDCOM file "; RTRIM$(FileName(XFile)); ".GED has been successfully converted."
              LOCATE 5, 6
              PRINT "The original GEDCOM file has been saved as "; RTRIM$(FileName(XFile)); ".OLD"
              LOCATE 8, 6
              PRINT "Do you want to process another GEDCOM file ? (Y/N)"
              Continue$ = " "
              DO
                    Continue$ = UCASE$(INKEY$)
                    LOCATE 8, 58: PRINT Continue$
              LOOP UNTIL INSTR(" YN", Continue$) > 1
              IF Continue$ = "N" THEN Prog = "finish"
          ELSE

              CALL Screenprep("", "", "", "", "", "", "", "", "", "Exit")
              LOCATE 4, 6
              PRINT "Do you want to rename the converted file? (Y/N)"
              LOCATE 4, 55
              PRINT Rename$
             
              LOCATE 8, 6
              PRINT "Please enter the name you wish to use for the modified file"
              LOCATE 9, 6: INPUT " ", RenameFile$
              RenameFile$ = UCASE$(RenameFile$)
              RenameFile$ = MID$(RenameFile$, 1, 8)
              IF INSTR(2, RenameFile$, ".") > 0 THEN
                   RenameFile$ = MID$(RenameFile$, 1, (INSTR(2, RenameFile$, ".") - 1))
              END IF
              SHELL "ren " + Path$ + RTRIM$(FileName(XFile)) + ".mod " + RTRIM$(RenameFile$) + ".ged"

              LOCATE 11, 6
              PRINT "GEDCOM file "; RTRIM$(FileName(XFile)); ".GED has been successfully converted."
              LOCATE 12, 6
              PRINT "The modified GEDCOM file has been saved as "; RTRIM$(RenameFile$); ".GED"
              LOCATE 15, 6
              PRINT "Do you want to process another GEDCOM file ? (Y/N)"
              Continue$ = " "
              DO
                    Continue$ = UCASE$(INKEY$)
                    LOCATE 15, 58: PRINT Continue$
              LOOP UNTIL INSTR(" YN", Continue$) > 1
              IF Continue$ = "N" THEN Prog = "finish"
       
          END IF
          Title = "Insert/Delete Commas in Place Lines of GEDCOM File"
     WEND
finish:
    END
RETURN

'-----------------------------------------------------------------------------------------------------------------------------------
SUB CheckLineType (LineString$, LineType$)
'This procedure checks for line types of "PLAC" (i.e. a field with place names)
'or "DATE"

        LineType$ = "O"
        IF MID$(LineString$, 3, 4) = "PLAC" THEN
            LineType$ = "P"
        END IF
        IF MID$(LineString$, 3, 4) = "DATE" THEN
            LineType$ = "D"
        END IF
      
END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB CheckNameLength (LineString$)
'This procedure checks the lengths of name pieces (i.e. the text between commas)
'If the name piece is longer than 16 characters, it inserts a comma in the closest space
'before the 16th character position

        CommaCount = 0
        CommaChars = 0
        StrLength = LEN(LineString$)
        StrPosition = LEN(LineString$)
        LastSpace = LEN(LineString$)
        StringChar = 8

'Count commas in place name
        WHILE StringChar < StrLength
            IF MID$(LineString$, StringChar, 1) = "," THEN
                    CommaCount = CommaCount + 1
            END IF
            StringChar = StringChar + 1
        WEND

'If more than two commas, cannot make any modification to place names
        IF CommaCount > 2 THEN
            GOTO EndModify
        ELSE
            CommaCount = 0
        END IF

'Examine place names - if there are any more than 16 characters between commas,
'replace first available space with a comma.  This procedure starts at highest
'character position and counts down, remembering the location of the last
'space; when it gets to more than 16 characters since the last comma it places
'a comma in the last space position i.e. in "Braxton by the Sea" a comma would
'be inserted after the word "Braxton"
        WHILE StrPosition > 8
            IF MID$(LineString$, StrPosition, 1) = "," THEN
                CommaCount = CommaCount + 1
                LastSpace = StrPosition
                CommaChars = 0
            ELSE
                IF MID$(LineString$, StrPosition, 1) = " " THEN
                    LastSpace = StrPosition
                END IF
                CommaChars = CommaChars + 1
                IF CommaChars > 16 THEN
                    IF (LastSpace - StrPosition < 16) THEN
                        MID$(LineString$, LastSpace, 1) = ","
                        CommaCount = CommaCount + 1
                        StrPosition = LastSpace
                    ELSE
                        GOTO EndModify
                    END IF
                END IF
            END IF
            IF CommaCount > 2 THEN
                GOTO EndModify
            END IF
            StrPosition = StrPosition - 1
        WEND
     
EndModify:

END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB ConvertDate (LineString$)
'This procedure converts dates that would be invalid in PAF to their valid
'equivalent

        TempString$ = LineString$
        TempString$ = UCASE$(TempString$)
        IF INSTR(TempString$, "PRE-") THEN
            MID$(LineString$, INSTR(TempString$, "PRE-"), 4) = "BEF "
        END IF
        IF INSTR(TempString$, "PRE ") THEN
            MID$(LineString$, INSTR(TempString$, "PRE "), 4) = "BEF "
        END IF
        IF INSTR(TempString$, "CIRCA") THEN
            MID$(LineString$, INSTR(TempString$, "CIRCA"), 5) = "ABT  "
        END IF
    
END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB DisplayFiles (MaxChoice AS INTEGER)
'This procedure displays the list of GEDCOM files found in the supplied path

    DIM XI AS INTEGER
    CALL Screenprep("", "", "", "", "", "", "", "", "", "Exit")
    LOCATE 2, 10
    PRINT "GEDCOM files found in path "; Path$
    LOCATE 4, 1
    FOR XI = XRec TO (XRec + 7)
        IF FileName(XI) <> "" THEN
            COLOR 1, 7
            PRINT USING "##"; MaxChoice;
            PRINT SPACE$(5); FileName(XI);
            PRINT SPACE$(5); FSize(XI);
            PRINT SPACE$(5); Date(XI);
            PRINT SPACE$(5); Time(XI)
            PRINT
            MaxChoice = MaxChoice + 1
        END IF
    NEXT XI
    MaxChoice = MaxChoice - 1
    IF FileName(XRec + 8) <> "" THEN
        COLOR 0, 7
        MaxChoice = MaxChoice + 1
        PRINT
        PRINT USING "##"; MaxChoice;
        PRINT SPACE$(5); "Show next group of GEDCOM files"
    END IF

END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB FunctionLine (f1 AS STRING, f2 AS STRING, f3 AS STRING, f4 AS STRING, f5 AS STRING, f6 AS STRING, f7 AS STRING, f8 AS STRING, f9 AS STRING, f10 AS STRING)

' f1 - f10 are the descriptions of the function keys.

     COLOR 0, 2
     MID$(TextLine, 1, 2) = " 1"
     MID$(TextLine, 9, 2) = " 2"
     MID$(TextLine, 17, 2) = " 3"
     MID$(TextLine, 25, 2) = " 4"
     MID$(TextLine, 33, 2) = " 5"
     MID$(TextLine, 41, 2) = " 6"
     MID$(TextLine, 49, 2) = " 7"
     MID$(TextLine, 57, 2) = " 8"
     MID$(TextLine, 65, 2) = " 9"
     MID$(TextLine, 73, 2) = "10"
     COLOR 7, 1
     MID$(TextLine, 3, 6) = f1
     MID$(TextLine, 11, 6) = f2
     MID$(TextLine, 19, 6) = f3
     MID$(TextLine, 27, 6) = f4
     MID$(TextLine, 35, 6) = f5
     MID$(TextLine, 43, 6) = f6
     MID$(TextLine, 51, 6) = f7
     MID$(TextLine, 59, 6) = f8
     MID$(TextLine, 67, 6) = f9
     MID$(TextLine, 75, 6) = f10
                                        
END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB GetDirectory (Text AS STRING, StartCol AS INTEGER)
'This procedure gets a list of GEDCOM files (*.GED) from the PATH specified by the user
    
     XTemp = 0
     DO UNTIL XTemp = 50
          XTemp = XTemp + 1
          FSize(XTemp) = ""
          Date(XTemp) = ""
          FileName(XTemp) = ""
          Time(XTemp) = ""
     LOOP
     SHELL "DIR " + Path$ + "*.GED > DIRECT.DIR"
     OPEN "DIRECT.DIR" FOR INPUT AS #1
     XRec = 0
     DO UNTIL EOF(1) OR (XRec = 50)
          LINE INPUT #1, Rec
          IF LEN(Rec) = 0 THEN Rec = " "
          IF MID$(Rec, StartCol, LEN(Text)) = Text THEN
               IF (LEFT$(Rec, 1) <> " ") AND (MID$(Rec, 17, 6) <> "     0") THEN
                    IF MID$(Rec, 14, 5) <> "<DIR>" THEN
                         XRec = XRec + 1
                         'The following lines allow for either possible date
                         'format(dd-mm-yy or mm-dd-yy.  Date will be displayed
                         'as either dd/mm/yy or mm/dd/yy
                         IF MID$(Rec, 24, 1) = " " THEN
                              MID$(Rec, 24, 1) = "0"
                         END IF
                         IF MID$(Rec, 27, 1) = " " THEN
                              MID$(Rec, 27, 1) = "0"
                         END IF
                         FSize(XRec) = MID$(Rec, 17, 6)
                         Date(XRec) = MID$(Rec, 24, 2) + "/" + MID$(Rec, 27, 2) + "/" + MID$(Rec, 30, 2)
                         FileName(XRec) = LEFT$(RTRIM$(LEFT$(Rec, 8)) + SPACE$(12), 12)
                         Time(XRec) = MID$(Rec, 34, 6) + "m"
                    END IF
               END IF
          END IF
     LOOP
     CLOSE
     KILL "DIRECT.DIR"

END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB GetSelection (MaxChoice AS INTEGER)
'This procedure gets the user to select which file they wish to convert

    COLOR 14, 7
    LOCATE 22, 5
    PRINT "Enter the number beside the desired file to process that file:"
    DO
        XChoice = VAL(INKEY$)
        LOCATE 22, 70: PRINT XChoice
    LOOP UNTIL (XChoice > 0) AND (XChoice <= MaxChoice)

    XFile = XRec + XChoice - 1

END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB InsertLeadCommas (LineString$)
'This procedure inserts leading commas until the place line has a total of 3 commas,
'thus ensuring that the last location field is always placed in the PAF level 4 location

        CommaCount = 0
        StrLength = LEN(LineString$)
        StringChar = 8
        IF StrLength > 6 THEN
            WHILE StringChar < StrLength
                IF MID$(LineString$, StringChar, 1) = "," THEN
                        CommaCount = CommaCount + 1
                END IF
                StringChar = StringChar + 1
            WEND
            WHILE CommaCount < 3
                LineString$ = MID$(LineString$, 1, 7) + "," + MID$(LineString$, 8, (StrLength - 7))
                StrLength = LEN(LineString$)
                CommaCount = CommaCount + 1
            WEND
        END IF
      
END SUB

'-------------------------------------------------------------------------------------------------------------------------------
SUB LeadCommaDel (LineString$)
'This procedure deletes any leading commas in PLAC lines in the GEDCOM file
       
        StrLength = LEN(LineString$)
        IF StrLength > 6 THEN
             WHILE MID$(LineString$, 8, 1) = ","
                  MID$(LineString$, 8) = MID$(LineString$, 9)
                  MID$(LineString$, (LEN(LineString$) - 1), 2) = LEFT$(RIGHT$(LineString$, 2), 1) + " "
             WEND
             WHILE MID$(LineString$, 8, 1) = " "
                  MID$(LineString$, 8) = MID$(LineString$, 9)
                  MID$(LineString$, (LEN(LineString$) - 1), 2) = LEFT$(RIGHT$(LineString$, 2), 1) + " "
             WEND
        END IF

END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB Screenprep (f1 AS STRING, f2 AS STRING, f3 AS STRING, f4 AS STRING, f5 AS STRING, f6 AS STRING, f7 AS STRING, f8 AS STRING, f9 AS STRING, f10 AS STRING)
' This will set up the screen layout. Based on Secondary Education Authority (W.Aust) standards.

'    The first line will be white background
'    The second line will be blue back. and white foreground
'    The second last will be the function bar. It will be blue and green back,
'    with white fore.
'    The last line will be white background.
'    All other lines will be white back and black fore.

     COLOR 0, 7
     CLS
     TextLine = SPACE$(80)
     CALL TopLine
     LOCATE 2, 1
     PRINT TextLine
     TextLine = SPACE$(80)
     CALL FunctionLine(f1, f2, f3, f4, f5, f6, f7, f8, f9, f10)
     LOCATE 24, 1
     PRINT TextLine
     COLOR 0, 7

END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB SelectFile (Text AS STRING, StartCol AS INTEGER)
'This procedure displays the list of GEDCOM files and then gets the user to select a file

     CALL GetDirectory(Text, StartCol)
     XRec = 1
     XChoice = 0
     DO UNTIL (XChoice > 0) AND (XChoice < 9)
          DIM MaxChoice AS INTEGER
          MaxChoice = 1
          CALL DisplayFiles(MaxChoice)
          CALL GetSelection(MaxChoice)
          SELECT CASE XChoice
               CASE 9
                    XRec = XRec + 8
               CASE ELSE
          END SELECT
     LOOP
  
END SUB

'-----------------------------------------------------------------------------------------------------------------------------------
SUB TopLine
'This will print the second line on the screen

    DIM Date AS STRING
    DIM length AS INTEGER
    DIM mmm AS STRING
    DIM start AS INTEGER
    DIM d1 AS STRING
    d1 = MID$(DATE$, 1, 2)

    COLOR 7, 1

    SELECT CASE d1
        CASE "01"
            mmm = "Jan"
        CASE "02"
            mmm = "Feb"
        CASE "03"
            mmm = "Mar"
        CASE "04"
            mmm = "Apr"
        CASE "05"
            mmm = "May"
        CASE "06"
            mmm = "Jun"
        CASE "07"
            mmm = "Jul"
        CASE "08"
            mmm = "Aug"
        CASE "09"
            mmm = "Sep"
        CASE "10"
            mmm = "Oct"
        CASE "11"
            mmm = "Nov"
        CASE "12"
            mmm = "Dec"
    END SELECT
     Date = MID$(DATE$, 4, 2) + " " + mmm + " " + MID$(DATE$, 7, 4)
     MID$(TextLine, 2, 11) = Date
     MID$(TextLine, 65, 5) = MID$(TIME$, 1, 5)
     MID$(TextLine, 72, 8) = Prog
     length = LEN(Title)
     start = (52 - length) / 2 + 13
     MID$(TextLine, start, length) = Title
                     
END SUB

